using System;
using System.Collections.Generic;
using System.Text;

namespace Iterator
{
    class Wheel
    {
        public override string ToString()
        {
            return "Wheel " + GetHashCode();
        }
    }


    class Door
    {
        public override string ToString()
        {
            return "Door" + GetHashCode();
        }
    }

    class Car
    {
        Wheel[] wheels = new Wheel[4];
        Door[] doors = new Door[4];

        public Car()
        {
            for(int i = 0; i < 4; i++) 
            { 
                wheels[i] = new Wheel(); 
                doors[i] = new Door();
            }
        }

        public IEnumerator<Wheel> GetEnumerator()
        {
            foreach(Wheel aWheel in wheels)
            {
                Console.WriteLine("Here within Car");
                yield return aWheel;
            }
        }

        public IEnumerable<Door> Doors
        {
            get
            {
                foreach(Door aDoor in doors)
                {
                    yield return aDoor;
                }
            }
        }
    }

    class Program
    {
        static void Main(string[] args)
        {
            Car myCar = new Car();

            foreach(Wheel wheel in myCar)
            {
                Console.WriteLine("Here in main");
                Console.WriteLine(wheel);
            }

            foreach(Door door in myCar.Doors)
            {
                Console.WriteLine(door);
            }
        }
    }
}
