﻿using System;
using System.Collections.Generic;
using System.Text;
using System.Query;
using System.Xml.XLinq;
using System.Data.DLinq;

namespace AnonymousMethods
{
    public delegate bool Evaluator(int val);

    public static class Enhancer
    {
        public static int[] Find(this int[] arr, Evaluator eval)
        {
            var lst = new List<int>();

            foreach(var val in arr)
            {
                if(eval(val)) 
                {
                    lst.Add(val);
                    break;
                }
            }

            return lst.ToArray();
        }

        public static int[] FindAll(this int[] arr, 
            Evaluator eval)
        {
            var lst = new List<int>();

            foreach(var val in arr)
            {
                if(eval(val)) lst.Add(val);
            }

            return lst.ToArray();
        }
    }

    class Program
    {
        static void Main(string[] args)
        {
            // Provides anonymous methods though Lambda Expressions.
            var lst = new int[] {1, 2, 3, 8, 7, 8, 9};

            Console.WriteLine("Find 8");
            ObjectDumper.Write(lst.Find(element => element == 8));

            Console.WriteLine("Find All numbers 8 or higher");
            ObjectDumper.Write(lst.FindAll(element => element >= 8));

            Console.WriteLine("Find All even numbers");
            ObjectDumper.Write(lst.FindAll(element => (element % 2) == 0));
        }
    }
}